%global somajor 1

%bcond_with hevc
%bcond_with check

Summary:        HEIF and AVIF file format decoder and encoder
Name:           libheif
Version:        1.16.2
Release:        3%{?dist}
License:        LGPL-3.0-or-later and MIT
URL:            https://github.com/strukturag/%{name}
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Patch0000:      libheif-no-hevc-tests.patch
Patch0001:	fixed-CVE-2024-25269-and-CVE-2023-49462.patch

BuildRequires:  cmake, gcc-c++, ninja-build
BuildRequires:  pkgconfig(aom), pkgconfig(dav1d), pkgconfig(libjpeg)
BuildRequires:  pkgconfig(libsharpyuv)
BuildRequires:  pkgconfig(rav1e)
BuildRequires:  pkgconfig(SvtAv1Enc)



%description
libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format)
file format decoder and encoder.

%package -n     heif-pixbuf-loader
Summary:        HEIF image loader for GTK+ applications
BuildRequires:  pkgconfig(gdk-pixbuf-2.0)
Requires:       %{name} = %{version}-%{release}
Requires:       gdk-pixbuf2

%description -n heif-pixbuf-loader
This package provides a plugin to load HEIF files in GTK+ applications.

%package        tools
Summary:        Tools for manipulating HEIF files
License:        MIT
Requires:       %{name} = %{version}-%{release}
Requires:       shared-mime-info

%description    tools
This package provides tools for manipulating HEIF files.



%if %{with hevc}
%package        hevc
Summary:        HEVC codec support for HEIC files
BuildRequires:  pkgconfig(libde265)
BuildRequires:  pkgconfig(x265)
Supplements:    %{name}

%description    hevc
This package adds support for HEVC-encoded HEIC files to applications
that use %{name} to read HEIF image files.
%endif

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.



%prep
%setup -q
%if %{without hevc}
%patch 0000 -p1
%endif
%patch 0001 -p1
rm -rf third-party/


%build
%cmake \
 -GNinja \
 -DPLUGIN_DIRECTORY=%{_libdir}/%{name} \
 -DWITH_UNCOMPRESSED_CODEC=ON \
 %{?with_check:-DBUILD_TESTING=ON -DWITH_REDUCED_VISIBILITY=OFF} \
 %{?with_hevc:-DWITH_LIBDE265_PLUGIN:BOOL=ON -DWITH_X265_PLUGIN:BOOL=ON} \
 -Wno-dev

%cmake_build

%install
%cmake_install

%if %{with check}
%check
%ctest
%endif



%files
%license COPYING
%doc README.md
%{_libdir}/*.so.%{somajor}{,.*}
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/%{name}-rav1e.so
%{_libdir}/%{name}/%{name}-svtenc.so

%files -n heif-pixbuf-loader
%{_libdir}/gdk-pixbuf-2.0/*/loaders/libpixbufloader-heif.so

%files tools
%{_bindir}/heif-*
%{_mandir}/man1/heif-*
%{_datadir}/thumbnailers/heif.thumbnailer

%if %{with hevc}
%files hevc
%{_libdir}/%{name}/%{name}-libde265.so
%{_libdir}/%{name}/%{name}-x265.so
%endif

%files devel
%{_libdir}/*.so
%{_libdir}/cmake/%{name}/
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/%{name}/



%changelog
* Wed Mar 20 2024 Rebuild Robot <rebot@opencloudos.org> - 1.16.2-3
- Rebuilt for dav1d

* Tue Mar 19 2024 Zhao Zhen <jeremiazhao@tencent.com> - 1.16.2-2
- fixed CVE-2024-25269 CVE-2023-49462

* Mon Nov 27 2023 Chair <chairou@tencent.com> - 1.16.2-1
- Init
